import memcache

class Cache:
    def __init__(self, **config):
        host = config.get("host", "127.0.0.1")
        port = config.get("port", 11211)
        self.m = memcache.Client(["%s:%s" % (host, port)], dead_retry=1)

    def set(self, key, value):
        try:
            self.m.set(key, value)
        except Exception:
            return None
        return True

    def get(self, key, default=None):
        try:
            v = self.m.get(key)
            if v is None:
                return default
            return v
        except Exception:
            return None

    def delete(self, key):
        try:
            return self.m.delete(key)
        except Exception:
            return None
