from bloonix.getopt import Getopt

def daemonize(name, class_object):
    p = Getopt()
    p.add_option(
        "-c", "--config-file",
        attr="config_file",
        value="config file",
        desc="The configuration file.",
        default="/etc/bloonix/%s/main.conf" % name
    )
    p.add_option(
        "-p", "--pid-file",
        attr="pid_file",
        value="pid file",
        desc="The PID file.",
        default="/var/run/bloonix-%s.pid" % name
    )
    p.add_option(
        "-b", "--background",
        desc="Run in background",
        default=False
    )
    p.add_option(
        "-l", "--log-level",
        attr="log_level",
        value="log level",
        desc="Log level for running in foreground",
        default="debug"
    )
    opts = p.parse_options()
    instance = class_object(
        config_file=opts["config_file"],
        pid_file=opts["pid_file"],
        background=opts["background"],
        log_level=opts["log_level"]
    )
    instance.startup()
