from bloonix.validator import validate

def validate_config(config):
    return validate(config, {
        "host": {
            "type": str,
            "default": "127.0.0.1"
        },
        "port": {
            "type": int,
            "optional": True
        },
        "database": {
            "type": str
        },
        "user": {
            "type": str
        },
        "password": {
            "type": str,
            "default": ""
        },
        "connect_timeout": {
            "type": int,
            "default": -1
        },
        "logger": {
            "type": dict,
            "optional": True,
            "allow_empty": True
        },
        "autocommit": {
            "type": bool,
            "default": True
        },
        "logger_name": {
            "type": str,
            "default": "bloonix-database",
        },
        "persistent": {
            "type": bool,
            "optional": True,
        },
        "max_connection_age": {
            "type": int,
            "default": 600,
        },
        "max_connection_uses": {
            "type": int,
            "default": 1000,
        },
    })
