from bloonix.logger import logger
from bloonix.findmod import load_path
import importlib
import os
import re

class Model:
    def __init__(self, heaven):
        self.log = logger("bloonix")
        self.heaven = heaven

    def autoload(self):
        paths = load_path("%s/%s" % (self.heaven.app_path, "model"))
        for p in paths:
            self.load(p)

    def load(self, *args):
        for arg in args:
            self._load(arg)

    def _load(self, name):
        alias = False
        if re.search(":", name):
            name, alias = name.split(":")

        module_name = "%s.model.%s" % (self.heaven.app_name, name)
        self.log.notice("load model", module_name)
        module = importlib.import_module(module_name)

        if hasattr(module, "Schema"):
            attr = getattr(module, "Schema")
        else:
            attr = getattr(module, "Model")

        if name in self.heaven._config["model"]:
            instance = attr(self.heaven._config["model"][name])
        else:
            instance = attr()

        accessor = re.sub(r"[^a-zA-Z_0-9]", "_", name)
        accessor = accessor.lower()
        self.log.notice("set model accessor", accessor, "for", module_name)
        setattr(self, accessor, instance)

        if alias and name != alias:
            self.log.notice("set model accessor", alias, "for", module_name)
            setattr(self, alias, instance)
