from bloonix.heaven import heaven
import bloonix.utils as utils
import time

"""
create table "token" (
  "tid" varchar(255) not null,
  "sid" varchar(255) not null,
  "expire" bigint not null,
  "action" varchar(100)
);
"""

class Token:
    def set(self, action="none"):
        expire = 30 # seconds
        token = utils.pwgen(64)
        sid = heaven.session_id
        heaven.model.db.token.create({
            "tid": token,
            "sid": sid,
            "expire": int(time.time()) + expire,
            "action": action
        })
        return token

    def get(self, action="none"):
        sid = heaven.session_id
        tid = heaven.req.param("token")

        if not tid or not isinstance(tid, str):
            return False

        heaven.model.db.token.delete(["where", ["expire", "<=", int(time.time())]])
        token = heaven.model.db.token.find("sid", sid, "tid", tid, "action", action)

        if not token:
            return False

        heaven.model.db.token.delete_by_col("tid", tid)
        return True

    def check(self, action="none"):
        if not heaven.plugin.token.get(action):
            return heaven.plugin.error.set("err-652")
        return True
