"""
This class makes it easier to use bloonix.validator.
Parameter are fetched from H.req.params and get_resultset
is set to true by default.
"""
import bloonix.validator
from bloonix.heaven import H

def validate(*args, **kwargs):
    return bloonix.validator.validate(*args, **kwargs)


class Validator(bloonix.validator.Validator):
    def __init__(self, *args, **kwargs):
        kwargs["get_resultset"] = kwargs.get("get_resultset", True)
        kwargs["log"] = H.log
        super().__init__(*args, **kwargs)

    def validate(self, data=None, ignore_missing=None):
        if data is None:
            params = self.get_params()
            data = H.req.params(params)
        return super().validate(data=data, ignore_missing=ignore_missing)


class Result(bloonix.validator.Result):
    pass
