import jinja2
import os

class View:
    def __init__(self, heaven):
        self.heaven = heaven
        template_path = heaven.template_path
        loader = jinja2.FileSystemLoader(template_path)
        self.jinja2 = jinja2.Environment(loader=loader)
        self.wrapper = None
        if os.path.isfile("%s/%s" % (template_path, "html-wrapper.html")):
            self.wrapper = "html-wrapper.html"
        elif os.path.isfile("%s/%s" % (template_path, "wrapper.html")):
            self.wrapper = "wrapper.html"

    def process(self):
        heaven = self.heaven

        if not heaven.res.content_type:
            heaven.res.content_type = "text/html; charset=utf-8"

        heaven.log.notice("start processing template", heaven.stash.template)

        if self.wrapper:
            template = self.jinja2.get_template(self.wrapper)
            heaven.stash.data["___template___"] = heaven.stash.template
            heaven.res.content = template.render(heaven.stash.data)
        else:
            template = self.jinja2.get_template(heaven.stash.template)
            heaven.res.content = template.render(heaven.stash.data)
