import decimal
import socket
import time
import json

class View:
    def __init__(self, heaven):
        self.heaven = heaven

    def process(self):
        heaven = self. heaven

        if not heaven.res.content_type:
            heaven.res.content_type = "application/json; charset=utf-8"

        data = heaven.stash.data
        data_type = type(data)

        if isinstance(data, (list, dict)):
            size = len(data)
        else:
            size = -1

        if isinstance(heaven.stash.total, int):
            total = heaven.stash.total
        else:
            total = -1

        dump_data = {
            "version": heaven.version,
            "maintenance": heaven.maintenance,
            "server_time": int(time.time() * 1000),
            "status": heaven.stash.status,
            "data": data,
            "size": size,
            "total": total
        }

        if heaven.req.exist("pretty") or heaven.req.request_method() == "GET":
            heaven.res.content = json.dumps(
                dump_data, indent=4, ensure_ascii=False, default=View.convert)
        else:
            heaven.res.content = json.dumps(
                dump_data, ensure_ascii=False, default=View.convert)

    def convert(o):
        if isinstance(o, decimal.Decimal):
            return float(o)
