import re
import sys
from bloonix.validator import validate

class ScreenOutput:
    def __init__(self, opts):
        self.validate(opts)
        self.opts = opts

    def validate(self, opts):
        validate(opts, {
            "log_to": {
                "type": str,
                "regex": re.compile(r"^(stdout|stderr)\Z"),
                "default": "stdout"
            }
        })

    def log(self, message, level):
        if self.opts["log_to"] == "stdout":
            print(message, flush=True)
        else:
            print(message, file=sys.stderr, flush=True)
