"""
All monitoring status levels for comparing and converting.
"""

# For comparing item codes.
OK = 0
INFO = 1
NOTICE = 2
WARNING = 3
ALERT = 4
CRITICAL = 5
UNKNOWN = 6
IS_OK = [0, 1]
NOT_OK = [2, 3, 4, 5, 6]
IS_OK_STR = ["OK", "INFO"]
NOT_OK_STR = ["NOTICE", "WARNING", "ALERT", "CRITICAL", "UNKNOWN"]
CODES = [0, 1, 2, 3, 4, 5, 6]

# Convert any string or code to code.
CODE = {
    "0": 0, 0: 0,
    "1": 1, 1: 1,
    "2": 2, 2: 2,
    "3": 3, 3: 3,
    "4": 4, 4: 4,
    "5": 5, 5: 5,
    "6": 6, 6: 6,
    "OK": 0, "ok": 0,
    "INFO": 1, "info": 1,
    "NOTICE": 2, "notice": 2,
    "WARNING": 3, "warning": 3,
    "ALERT": 4, "alert": 4,
    "CRITICAL": 5, "critical": 5,
    "UNKNOWN": 6, "unknown": 6
}

# Convert code to string.
STRING = {
    0: "OK",
    1: "INFO",
    2: "NOTICE",
    3: "WARNING",
    4: "ALERT",
    5: "CRITICAL",
    6: "UNKNOWN",
    "0": "OK",
    "1": "INFO",
    "2": "NOTICE",
    "3": "WARNING",
    "4": "ALERT",
    "5": "CRITICAL",
    "6": "UNKNOWN",
    "ok": "OK",
    "info": "INFO",
    "notice": "NOTICE",
    "warning": "WARNING",
    "alert": "ALERT",
    "critical": "CRITICAL",
    "unknown": "UNKNOWN",
    "OK": "OK",
    "INFO": "INFO",
    "NOTICE": "NOTICE",
    "WARNING": "WARNING",
    "ALERT": "ALERT",
    "CRITICAL": "CRITICAL",
    "UNKNOWN": "UNKNOWN",
}

# Convert nagios code to bloonix code.
NAGIOS = {
    0: CODE["OK"],
    1: CODE["WARNING"],
    2: CODE["CRITICAL"],
    3: CODE["UNKNOWN"]
}
