import signal
import bloonix.exception

class RunCode:
    def signal_handler(signum, frame):
        raise bloonix.exception.BloonixTimeout

    def __init__(self, timeout, callback, args=None, kwargs=None):
        self.timed_out = None
        self.data = None

        try:
            signal.signal(signal.SIGALRM, RunCode.signal_handler)
            signal.alarm(timeout)
            if args is None and kwargs is None:
                self.data = callback()
            elif args is None:
                self.data = callback(**kwargs)
            elif kwargs is None:
                self.data = callback(*args)
            else:
                self.data = callback(*args, **kwargs)
            signal.alarm(0)
        except bloonix.exception.BloonixTimeout:
            self.timed_out = True


