GSM_7BIT_CHARS = (
    "@£$¥èéùìòÇ\nØø\rÅåΔ_ΦΓΛΩΠΨΣΘΞ\x1BÆæßÉ !\"#¤%&'()*+,-./0123456789:;<=>?"
    "¡ABCDEFGHIJKLMNOPQRSTUVWXYZÄÖÑÜ§¿abcdefghijklmnopqrstuvwxyzäöñüà"
)

def is_gsm_7bit(text):
    return all(c in GSM_7BIT_CHARS for c in text)

def count_utf16_code_units(text):
    # 2 Byte = 1 Code Unit
    return len(text.encode("utf-16-le")) // 2

def truncate_to_one_sms(message):
    if is_gsm_7bit(message):
        return message[:160]
    # Max 70 Code Units
    max_units = 70
    while count_utf16_code_units(message) > max_units:
        message = message[:-1]
    return message
