import re
ALLOWED_OPTIONS = [
    "validator",
    # str, int, float, dict, list, bool
    "type",
    # default value if not set
    "default",
    # ignore the key if not exist
    "optional",
    # min max number
    "minvalue",
    "maxvalue",
    # min and max length string. if the value is a list or
    # a dict, then the value is converted to a string with
    # json.dumps and measured
    "minlength",
    "maxlength",
    # min max keys or elements in dict/list
    "minsize",
    "maxsize",
    # convert a value, e.g. bits to bytes, or parse for a specific format
    "isa",
    # pass a timezone for conversion
    "isa_unixtime",
    # A list of options from which only one may be selected
    "options",
    # A list of options from which several may be selected
    "multioptions",
    # A list of dicts. The param must be set in each dict.
    "list_of_dicts_options",
    "list_of_dicts_multioptions",
    # What key to use from the dict for validation.
    # By default the parameter is used.
    "list_of_dicts_key",
    # A function to validate the value.
    "function",
    "function_args",
    "function_kwargs",
    # Regular expression
    "regex",
    # Comma separated list
    "regex_cl",
    # Allow empty strings, dicts, lists
    "allow_empty",
    # allow None
    "allow_none",
    # Convert
    "force_list",
    # Remove the key from data if the password contains
    # only stars: ^\*+\Z
    "password",
    # force the value to be a list and validate each value individually
    "multiple",
    # if a string is empty, then set the string to 0 or None
    "empty_to_null",
    "empty_to_none",
    # post validation
    "depends_on",
]
ALLOWED_DEPENDS_ON_OPTIONS = [
    "lower_or_greater",
    "max_diff",
]
LIST_OPTIONS = [
    "options",
    "multioptions",
    "list_of_dicts_options",
    "list_of_dicts_multioptions",
]
ERROR_MESSAGE = {
    "err-700": "The parameter is mandatory",
    "err-701": "An unexpected error occurs",
    "err-702": "The value too low",
    "err-703": "The value too high",
    "err-704": "The value is too short",
    "err-705": "The value is too long",
    "err-706": "Not enough elements",
    "err-707": "Too much elements",
    "err-710": "The value is invalid",
    "err-711": "One or more values are invalid",
    "err-712": "Invalid data type",
    "err-713": "The object size is too short",
    "err-714": "The object exceeded maximum allowed size",
    "err-715": "The parameter does not exists",
    "err-716": "An empty object is not allowed",
    "err-717": "The value is missing",
    "err-718": "Expecting a list of values",
    "err-719": "The parameter may not be mixed with other parameters",
    "err-720": "The data structure is faulty",
}
BYTES = {
    "b": 1,
    "k": 1024,
    "m": 1048576,
    "g": 1073741824,
    "t": 1099511627776,
    "p": 1125899906842624,
    "e": 1152921504606846976
}
TIME = {
    "m": 60,
    "h": 3600,
    "d": 86400
}
RE_TYPE_NAME = type(re.compile("")).__name__
