import os
import re
from setuptools import setup

# rockylinux 8 has no find_namespace_packages
def __find(where, pre="", packages=[]):
    for path in os.listdir("%s/%s" % (where, pre)):
        if path == "__pycache__":
            continue
        if pre == "":
            search_path = "%s/%s" % (where, path)
        else:
            search_path = "%s/%s/%s" % (where, pre, path)
        if os.path.isdir(search_path):
            if pre == "":
                packages.append(path)
                __find(where, path, packages)
            else:
                packages.append("%s.%s" % (re.sub(r"/", ".", pre), path))
                __find(where, "%s/%s" % (pre, path), packages)
    return packages

try:
    from setuptools import find_namespace_packages
except Exception:
    find_namespace_packages = __find

setup(
    name="bloonix-core",
    version="0.1",
    author="Jonny Schulz",
    author_email="js@bloonix.de",
    description="Python 3 core modules for the Bloonix Framework",
    license="Copyright (C) 2023 by Jonny Schulz - js@bloonix.de. All rights reserved.",
    include_package_data=False,
    packages=find_namespace_packages(where="lib"),
    package_dir={"": "lib"},
)
