#!/usr/bin/python3

import os
import pwd
import sys
import unittest
sys.path.insert(0, "bloonix")
from bloonix.exception import BloonixError
import bloonix.procutils as procutils

class TestTemplate(unittest.TestCase):

    def test_01(self):
        procutils.switch_group("bloonix")
        self.assertTrue(os.getegid() == pwd.getpwnam("bloonix").pw_gid)

    def test_02(self):
        procutils.switch_user("bloonix")
        self.assertTrue(os.geteuid() == pwd.getpwnam("bloonix").pw_uid)

    def test_03(self):
        if os.path.exists("/tmp/bloonix-procutils-python-test.pid"):
            os.remove("/tmp/bloonix-procutils-python-test.pid")
        procutils.create_pid_file("/tmp/bloonix-procutils-python-test.pid")
        f = open("/tmp/bloonix-procutils-python-test.pid", "r")
        line = f.readline()
        f.close()
        self.assertTrue(str(os.getpid()) == line)

    def test_04(self):
        procutils.change_directory()
        self.assertTrue(os.getcwd() == "/")

    def test_99(self):
        procutils.redirect_output()


unittest.main(verbosity=2)
