#!/usr/bin/python3

import unittest
from bloonix.exception import BloonixError
import bloonix.ccodes as ccodes

class TestTemplate(unittest.TestCase):
    def test_country_code(self):
        codes = ccodes.country
        self.assertTrue(codes["DE"] == "DE - Germany")

    def test_continent_code(self):
        codes = ccodes.continent
        self.assertTrue(codes["EU"] == "Europe")

    def test_country_code_form(self):
        form = ccodes.country_as_form()
        self.assertTrue(form[0]["label"] == "AD - Andorra")

    def test_continent_code_form(self):
        form = ccodes.continent_as_form()
        self.assertTrue(form[0]["label"] == "Africa")
        self.assertTrue(form[0]["value"] == "AF")

    def test_country_continent(self):
        codes = ccodes.country
        country_continent = ccodes.country_continent

        for c in codes:
            self.assertTrue(c in country_continent)

        for c in country_continent:
            self.assertTrue(c in codes)


unittest.main(verbosity=2)
