#!/usr/bin/python3

import unittest
import bloonix.netaddr as netaddr

class TestTemplate(unittest.TestCase):
    def test_01(self):
        self.assertTrue(netaddr.ip_in_network("::1", "::1/128"))

    def test_02(self):
        self.assertTrue(netaddr.ip_in_network("::3", ["::1/128","::2/128","::3/128"]))

    def test_03(self):
        self.assertFalse(netaddr.ip_in_network("::3", "::1/128"))
        self.assertFalse(netaddr.ip_in_network("::3", "::2/128"))

    def test_11(self):
        self.assertTrue(netaddr.ip_in_network("127.0.0.1", "127.0.0.1/32"))

    def test_12(self):
        self.assertTrue(netaddr.ip_in_network("127.0.0.3", ["127.0.0.1/32","127.0.0.2/32","127.0.0.3/32"]))

    def test_13(self):
        self.assertFalse(netaddr.ip_in_network("127.0.0.3", "127.0.0.1/32"))
        self.assertFalse(netaddr.ip_in_network("127.0.0.3", "127.0.0.2/32"))


unittest.main(verbosity=2)
