#!/usr/bin/python3

import unittest
from bloonix.plugin.base import Check

class TestPluginBase(unittest.TestCase):
    def __init_compare_string(self, *argv):
        check = Check(
            version="1.0",
            service="test",
            category="test",
            abstract="test",
            description="test",
            argv=list(argv))
        check.has_string(
            key="state",
            name="state",
            description="state")
        opt = check.parse_options()
        check.check_matches(data={"state": "ALIVE"})
        return check.exit(return_status=True)

    def test_compare_string(self):
        ret = self.__init_compare_string("--match-critical", "state:ne:ALIVE")
        self.assertTrue(ret["status"] == "OK")

        ret = self.__init_compare_string("--match-critical", "state:eq:ALIVE")
        self.assertTrue(ret["status"] == "CRITICAL")

        ret = self.__init_compare_string("--match-critical", "state:re:ALIVE")
        self.assertTrue(ret["status"] == "CRITICAL")

        ret = self.__init_compare_string("--match-critical", "state:rn:ALIVE")
        self.assertTrue(ret["status"] == "OK")

        ret = self.__init_compare_string("--match-critical", "state:ne:ERROR")
        self.assertTrue(ret["status"] == "CRITICAL")

        ret = self.__init_compare_string("--match-critical", "state:eq:ERROR")
        self.assertTrue(ret["status"] == "OK")

        ret = self.__init_compare_string("--match-critical", "state:re:ERROR")
        self.assertTrue(ret["status"] == "OK")

        ret = self.__init_compare_string("--match-critical", "state:rn:ERROR")
        self.assertTrue(ret["status"] == "CRITICAL")


unittest.main(verbosity=2)
